@echo off
title GOP Updater
pushd %~dp0
::TODO microcode ask-remove, take lastGOP from GOP_Files?, romscan-efiscan
::TODO save extra data, report bad images, integrity check

:req
if NOT exist UEFIRomExtract.exe (
	echo;
	echo UEFIRomExtract.exe not found! Add it to the current folder.
	echo;
	pause
	exit
)
if NOT exist cecho.exe (
	echo;
	echo cecho.exe not found! Add it to the current folder.
	echo;
	pause
	exit
)


rem Admin rights from https://stackoverflow.com/questions/7044985/how-can-i-auto-elevate-my-batch-file-so-that-it-requests-from-uac-administrator

setlocal EnableDelayedExpansion

NET FILE 1>NUL 2>NUL
if '%errorlevel%' == '0' ( goto START ) else ( goto getPrivileges )

:getPrivileges
rem echo All args before elev = %* && pause
if '%1'=='ELEV' ( goto START )

set "batchPath=%~f0"
set "batchArgs=ELEV"

::Add quotes to the batch path, if needed
set "script=%0"
set script=%script:"=%
IF '%0'=='!script!' ( GOTO PathQuotesDone )
    set "batchPath=""%batchPath%"""
:PathQuotesDone

::Add quotes to the arguments, if needed.
:ArgLoop
IF '%1'=='' ( GOTO EndArgLoop ) else ( GOTO AddArg )
    :AddArg
    set "arg=%1"
    set arg=%arg:"=%
    IF '%1'=='!arg!' ( GOTO NoQuotes )
        set "batchArgs=%batchArgs% "%1""
        GOTO QuotesDone
        :NoQuotes
        set "batchArgs=%batchArgs% %1"
    :QuotesDone
    shift
    GOTO ArgLoop
:EndArgLoop

::Create and run the vb script to elevate the batch file
ECHO Set UAC = CreateObject^("Shell.Application"^) > "%temp%\OEgetPrivileges.vbs"
ECHO UAC.ShellExecute "cmd", "/c ""!batchPath! !batchArgs!""", "", "runas", 1 >> "%temp%\OEgetPrivileges.vbs"
"%temp%\OEgetPrivileges.vbs"
if exist "%temp%\OEgetPrivileges.vbs" del "%temp%\OEgetPrivileges.vbs" >nul
exit /B

:START
::Remove the elevation tag and set the correct working directory
rem echo All args after elev = %* && pause
if '%1'=='ELEV' SHIFT /1
rem echo First arg after shift = %1 && pause
rem echo All args after shift = %* && pause
cd /d %~dp0

setlocal DisableDelayedExpansion


:header
echo;
cecho {lime}************************* GOPupd 1.9.5 ************************* {default}{\n}
echo;
echo;
cecho {lime}************************ Update EFI GOP ************************ {default}{\n}
echo;
echo;
cecho {lime}***************** Drop VBIOS file on this .bat ***************** {default}{\n}
echo;
echo;

if exist GOPupd.py for %%X in (python.exe) do (set pyexe=%%~$PATH:X)
if exist GOPupd.py if exist C:\Python34\python.exe set pyexe=C:\Python34\python.exe
if defined pyexe (set script=%pyexe% GOPupd.py) else set script=GOPupd.exe
if "%script%" == "GOPupd.exe" (set exec=GOPupd) else set exec=Python

:catch
set first_arg=%~1
if "%first_arg%" == "" cecho {yellow}Drop the files on this bat, DON'T run it! Browsing for file...{default}{\n} && echo; && pause && echo; && goto select_file
for %%i in (%*) do (
	set name=%%~ni
	set ext=%%~xi
	set vbios=%%~nxi
	set vbios_path=%%~dpnxi
	if NOT "%%i" == "ELEV" call :loop_main && cls
)
exit

:select_file
rem Function taken from UBU - http://www.win-raid.com/t154f16-Tool-Guide-News-quot-UEFI-BIOS-Updater-quot-UBU.html
setlocal
for /f "usebackq delims=" %%i in (
	`@"%systemroot%\system32\mshta.exe" "about:<FORM><INPUT type='file' name='qq'></FORM><script>document.forms[0].elements[0].click();var F=document.forms[0].elements[0].value;try {new ActiveXObject('Scripting.FileSystemObject').GetStandardStream(1).Write(F)};catch (e){};close();</script>" ^
	1^|more`
) do (set name=%%~ni) && (set ext=%%~xi) && (set vbios=%%~nxi) && set vbios_path=%%~dpnxi
if "%vbios_path%" == "" cecho {yellow}No file was selected. Drop the files or launch and select a file...{default}{\n} && echo; && pause && exit
endlocal && (set name=%name%) && (set ext=%ext%) && (set vbios=%vbios%) && set vbios_path=%vbios_path%
call :loop_main
exit

:loop_main

cecho {aqua}Dumping info from = {gray}%vbios% {default}{\n} && echo; && echo;

:extefirom
if not exist "%vbios%"_temp\ mkdir "%vbios%"_temp
if exist "%vbios%"_newGOP\ rmdir /s /q "%vbios%"_newGOP\
if exist "%vbios%"_temp\\"%name%"_compr.efirom del "%vbios%"_temp\\"%name%"_compr.efirom >nul
if exist "%vbios%"_temp\\"%name%"_dump.efi del "%vbios%"_temp\\"%name%"_dump.efi >nul
%script% "%vbios_path%" ext_efirom


:dumpinfo
if not exist "%vbios%"_temp\\"%name%"_compr.efirom goto gopupdate
echo;
cecho {olive}*************************************************************** {default}{\n}
cecho {olive}***         Extracting with UEFIRomExtract by AndyV         *** {default}{\n}
cecho {olive}*************************************************************** {default}{\n}
echo;
UEFIRomExtract.exe "%vbios%"_temp\\"%name%"_compr.efirom "%vbios%"_temp\\"%name%"_dump.efi
echo;
cecho {maroon}--------------------------------------------------------------- {default}{\n}
echo;


:gopupdate
if not exist "%vbios%"_temp\\"%name%"_dump.efi cecho {red}No EFI ROM found or error on decompression !!! {default}{\n} && echo;
rem echo;
cecho {green}*************************************************************** {default}{\n}
cecho {green}***                Extracting with %exec%...                *** {default}{\n}
cecho {green}*************************************************************** {default}{\n}
echo;
%script% "%vbios_path%" gop_upd
echo;
cecho {maroon}--------------------------------------------------------------- {default}{\n}

:: Use ISBN=1 for extracting certificate.
:: Use DEBUG=1 for displaying certificate container and structure.
set ISBN=0
set DEBUG=0
if "%ISBN%" == "0" goto exit_gop

:isbn_info
if "%DEBUG%" == "1" (set DEBUG=info) else set DEBUG=
echo;
cecho {green}*************************************************************** {default}{\n}
cecho {green}***                Processing ISBN signature                *** {default}{\n}
cecho {green}*************************************************************** {default}{\n}
echo;
%script% "%vbios_path%" ISBN %DEBUG%
echo;
cecho {maroon}--------------------------------------------------------------- {default}{\n}

:exit_gop
echo; && echo; && echo Press any key to exit.. && pause>nul
if exist "%vbios%"_temp\ rmdir /s /q "%vbios%"_temp\
exit /b